/*********************************************
 "dimmer_tn2313"
  "dimmer"   2007-2-41
  
*********************************************/
// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATtiny2313


#pragma used+
#pragma used+
sfrb DIDR=1;
sfrb UBRRH=2;
sfrb UCSRC=3;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb USICR=0xd;
sfrb USISR=0xe;
sfrb USIDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb GPIOR0=0x13;
sfrb GPIOR1=0x14;
sfrb GPIOR2=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb PCMSK=0x20;
sfrb WDTCR=0x21;
sfrb TCCR1C=0x22;
sfrb GTCCR=0x23;
sfrb ICR1L=0x24;
sfrb ICR1H=0x25;
sfrw ICR1=0x24;   // 16 bit access
sfrb CLKPR=0x26;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;   // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;   // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCCR0A=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb EIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb OCR0B=0x3c;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// for compatibility with the interrupt vector names from Atmel's datasheet


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


                          //  
unsigned char s_reg;      // SREG

unsigned char ofa;        //  ->  ofa_min <= ofa <= ofa_max
unsigned char mode;       // 

                          //     timer1.
char second_half_period;  //second_half_period= 
unsigned int timer_ofa;   //   ofa;

// .
void keyboard(void)
{
if(PIND.6==0)           //  "-"
	{
		mode=1;             //  
	  return;
	}

if(PIND.5==0)           //  "+"
	{
		mode=2;             //  
	  return;
	}

//       ,    .
if(mode==1 || mode==2) mode=3;
}

//     
//  INT0 PD2 
interrupt [2] void ext_int0_isr(void)
{
s_reg=SREG;

second_half_period=0; //     timer1.
                      //bit second_half_period=0
TCNT1H=255;           // timer1 0xFF; 
TCNT1L=ofa;           //ofa  118  232

TIMSK=0b10000000;     //    
                      //bit7  . /1   bit1  . /0
SREG=s_reg;                     
}

//==========================================================
//  1 ( ).
//==========================================================
interrupt [6] void timer1_ovf_isr(void)
{
// 
s_reg=SREG;
#asm
	PUSH	R30
#endasm

//     
PORTB=0b00000001;                   // 1  PORTB.0-.  
delay_us(10);                       // 9 us  delay_us(9);

PORTB=0b00000000;                   // 0  PORTB.0-.  
                                    // 10       
                                    // 10   .
TCNT1=65380;                        // TCNT1
if(second_half_period) TIMSK=0x00;  // second_half_period=1
                                    //  TCNT1
second_half_period=1;               //

// 
#asm
	POP	R30
#endasm
SREG=s_reg;
}

void main(void)
{
// Port B initialization
DDRB =0b11111111;
PORTB=0b11111111;

// Port D initialization
 DDRD=0b0000000;  //  .
PORTD=0b1100000;  // . 

// Timer/Counter 0 initialization
// Clock source: System Clock
TCCR0B=0x00;    //.
TCNT0=0x00;     //.
                //  
// Timer(s)/Counter(s) Interrupt(s) initialization
//TIMSK=0x02; //0b10  Bit 1 Interrupt Enable TC0   TIMSK=0b10000010;
TIMSK=0b10000000; //bit1-. . 0  bit7-. . 1

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz (  125    8 )
TCCR1B=0x04;    //0b100   CK/256 4000/256=15,625 
TCCR1A=0x00;    //
TCNT1H=0x00;
TCNT1L=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: Off
//General Interrupt Mask Register  .  INT0
MCUCR=0x03;                     //0b11       INT0
GIMSK=0x40;                     //0b01000000    . INT0=PD2
                                //MCUCR=MCU Control Register 

ACSR=0x80;                      //Analog Comparator Output: Off

ofa=128       ;                    //  (  ofa=118)
#asm("sei");                    //  

while (1)
	{
	  keyboard();

	  switch(mode)
		{
		  case 1:                   //    
      if(GIMSK==0x00)           //General Interrupt Mask Register  .  INT0
	    {                         //    0
	      mode=3;                 //   INT0 .   mode3
	      break;
	    }

      if(++timer_ofa>7500)        //if(++timer_ofa>7500)
	    {
	      timer_ofa=0;
	    
	      if(ofa>128       ) ofa--;
	      else GIMSK=0x00;        // .  INT0
	    }
	    break;
		
		case 2:                     //  
    if(GIMSK==0x00)             //     GIMSK  = 0
	  {                           //
	    ofa=128       ;              //    . 128
	    GIMSK=0x40;               //.  INT0
	    timer_ofa=0;              //  timer_ofa
	  }

    if(++timer_ofa>7500)          // 7500   
	  {                           // timer_ofa   7500
	    timer_ofa=0;              // timer_ofa
	    if(ofa<249       ) ofa++;    //  1  ofa
	    else mode=3;
	  }
			break;
		
		case 3:                     //     
    break;
		}
	}
}
