/*********************************************
 "dimmer_tn2313"
  "dimmer"   2007-2-41
  
*********************************************/
#include "TINY2313.H"
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#include "delay.h"

#define ofa_min 128       //0x80=128 (ofa -  )
#define ofa_max 249       //0xE8=232 238 max    max 249 PROTEUS
                          // 
unsigned char s_reg;      // SREG

unsigned char ofa;        //  ->  ofa_min <= ofa <= ofa_max
unsigned char mode;       // 

                          //     timer1.
char second_half_period;  //second_half_period= 
unsigned int timer_ofa;   //   ofa;

// .
void keyboard(void)
{
if(PIND.6==0)           //  "-"
	{
		mode=1;             //  
	  return;
	}

if(PIND.5==0)           //  "+"
	{
		mode=2;             //  
	  return;
	}

//       ,    .
if(mode==1 || mode==2) mode=3;
}

//     
//  INT0 PD2
interrupt [EXT_INT0] void ext_int0_isr(void)
{
s_reg=SREG;

second_half_period=0; //     timer1.
                      //bit second_half_period=0
TCNT1H=255;           // timer1 0xFF;
TCNT1L=ofa;           //ofa  118  232

TIMSK=0b10000000;     //    
                      //bit7  . /1   bit1  . /0
SREG=s_reg;
}

//==========================================================
//  1 ( ).
//==========================================================
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
// 
s_reg=SREG;
#asm
	PUSH	R30
#endasm

//     
PORTB=0b00000001;                   // 1  PORTB.0-.  
delay_us(10);                       // 9 us  delay_us(9);

PORTB=0b00000000;                   // 0  PORTB.0-.  
                                    // 10       
                                    // 10   .
TCNT1=65380;                        // TCNT1
if(second_half_period) TIMSK=0x00;  // second_half_period=1
                                    //  TCNT1
second_half_period=1;               //

// 
#asm
	POP	R30
#endasm
SREG=s_reg;
}

void main(void)
{
// Port B initialization
DDRB =0b11111111;
PORTB=0b11111111;

// Port D initialization
 DDRD=0b0000000;  //  .
PORTD=0b1100000;  // . 

// Timer/Counter 0 initialization
// Clock source: System Clock
TCCR0B=0x00;    //.
TCNT0=0x00;     //.
                //  
// Timer(s)/Counter(s) Interrupt(s) initialization
//TIMSK=0x02; //0b10  Bit 1 Interrupt Enable TC0   TIMSK=0b10000010;
TIMSK=0b10000000; //bit1-. . 0  bit7-. . 1

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz (  125    8 )
TCCR1B=0x04;    //0b100   CK/256 4000/256=15,625 
TCCR1A=0x00;    //
TCNT1H=0x00;
TCNT1L=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: Off
//General Interrupt Mask Register  .  INT0
MCUCR=0x03;                     //0b11       INT0
GIMSK=0x40;                     //0b01000000    . INT0=PD2
                                //MCUCR=MCU Control Register

ACSR=0x80;                      //Analog Comparator Output: Off

ofa=ofa_min;                    //  (  ofa=118)
#asm("sei");                    //  

while (1)
	{
	  keyboard();

	  switch(mode)
		{
		  case 1:                   //  
      if(GIMSK==0x00)           //General Interrupt Mask Register  .  INT0
	    {                         //    0
	      mode=3;                 //   INT0 .   mode3
	      break;
	    }

      if(++timer_ofa>7500)        //if(++timer_ofa>7500)
	    {
	      timer_ofa=0;

	      if(ofa>ofa_min) ofa--;
	      else GIMSK=0x00;        // .  INT0
	    }
	    break;

		case 2:                     //  
    if(GIMSK==0x00)             //     GIMSK  = 0
	  {                           //
	    ofa=ofa_min;              //    . 128
	    GIMSK=0x40;               //.  INT0
	    timer_ofa=0;              //  timer_ofa
	  }

    if(++timer_ofa>7500)          // 7500   
	  {                           // timer_ofa   7500
	    timer_ofa=0;              // timer_ofa
	    if(ofa<ofa_max) ofa++;    //  1  ofa
	    else mode=3;
	  }
			break;

		case 3:                     //     
    break;
		}
	}
}
